/*  
	Program:	CHF.prg  (originally CHF4DBF.prg on CIS)
	Author:   Steve Kolterman
	Date:     03-09-91 (modified 4/21/91)
	Version:  Clipper 5.0    (clipper CHF /n/m/a)
	Notes:    This program will produce a header file containing
	#define directives for each field in a database.  The values 			assigned are the same as their position in the database structure.
	Modified: by Tom Walden, to allow the user to add an optional
	prefix to the DEFINE declarations for uniqueness.  */

// Since this program is provided merely as a convenience with the
// article, it will contain very few comments within.            

#include "Chf.ch" 			// Make sure you have this file also
MEMVAR GetList
STATIC err_cume := 0		// Error counter
STATIC cSymbol  := '  '		// Prefix

FUNCTION MakeChFile( dbff, ch_name )   // The shell
	LOCAL fn_array, w_area := SELECT(), path
	LOCAL oldcurs:= SETCURSOR(SC_NONE)
	SET SCORE OFF
	SET CURSOR ON

	IF dbff <> NIL .AND. FILE( DBF_NAME )
		// New code starts here
   		BEEP2
		SETCOLOR('r/w')
		CLEAR SCREEN
		SETCOLOR('gr+/b')
		@ 8,18 CLEAR TO 14,61
		@ 8,18 TO 14,61 DOUBLE
		@ 10,22 SAY 'Character prefix for field name: ' ;
			GET cSymbol PICT '@'
		@ 12,22 SAY '(Examples:  _  m  __  ^ , or none)'
		READ
		cSymbol  := trim(cSymbol)
		// End of new code
		fn_array := DIRECTORY( IF(WILDCARD,dbff,DBF_NAME) )
		ch_name  := IF( fn_array == NIL .OR. LEN(fn_array) > 1, ;
			NIL, ch_name )
		IF fn_array <> NIL
			path  := IF("\" $dbff .OR. ":\" $dbff, ;
				LEFT(dbff, RAT("\",dbff)), ;
			IF(":" $dbff, LEFT(dbff, RAT(":", dbff)),""))
				AEVAL( fn_array, ;
 				{|x,y| WriteCh( path,fn_array[y][F_NAME],ch_name )})
   			ENDIF
		ENDIF

		SELECT(w_area)
		IF NIL_COND .OR. err_cume >0; 
			Qout("Need A Valid .DBF spec"); 
			END
			SETCURSOR(oldcurs)
			@ 18,37 SAY 'DONE!!'    	// New code
			BEEP3                   	// New code
	RETURN ( err_cume )

FUNCTION WriteCh( path,dbffile,ch_name )     // The author
	LOCAL handle, dummy:= {}
	IF ( handle := FCREATE( IF(ch_name == NIL, (CH_NAME), ;
			ch_name + ".CH" )) ) <> F_ERROR
		USE (path+dbffile) NEW
		ASIZE( dummy, FCOUNT() )
		FWRITE( handle, HEADLINE + TYPELINE )
		AEVAL( dummy, {|x,y| FWRITE( handle, BUFFER ) } )
		FWRITE( handle, FOOTLINE + CREDIT + COPYRITE )
		USE
	ENDIF

	IF handle== -1; err_cume++; END
		FCLOSE( handle )
	RETURN ( handle )

/*  SK_Field.prg
	The SK Field Functions.  Pass 'em either a field name or an
	ordinal .dbf position.  We don't care. Release 1.1: March 9, 1991.
*/
#define FGV   fieldget( var )
#define VTFGV valtype( (FGV) )
#define FBV   FieldBlock(var)
#define FBFNV FieldBlock(fieldname(var))
#define EVFBV Eval( (FBV) )
#define VTFV  valtype( EVFBV )
#define VTV   valtype( var )
#define TNUM  IF( !(VTV) $"NC",NIL,IF( (VTV)=="N",(VTFGV),(VTFV) ))
#define TCHR  IF( !(VTV) $"NC",NIL,IF( (VTV)=="N",(FGV),(EVFBV) ))
#define DBS_NAME 1
#translate ATRIM( <x> ) => LTRIM(TRIM( <x> ))

/***
This series returns character or logical values 
***/

FUNCTION FieldVal( var )
	RETURN (TCHR)

FUNCTION FieldType( var )
	RETURN (TNUM)

FUNCTION FieldPlace( var,value )
	RETURN EVAL( IF((VTV) == "N", (FBFNV), (FBV)), value )

FUNCTION FieldExist( var )
	RETURN IF( (VTV) == "N", (FBFNV <> NIL),;
		 IF( (VTV) == "C", (FBV <> NIL), .F. ))

/***
 This series returns numeric values 
***/

FUNCTION FieldLen( var )
	RETURN IF( (TNUM)=="D",LEN(DTOC( (TCHR) )),;
		IF( (TNUM)=="L",1,;
		IF( (TNUM)=="M",10,;
		IF( (TNUM)=="C",LEN( (TCHR) ),;
		IF( (TNUM)=="N",LEN(STR( (TCHR) )),-1 ) ))))

FUNCTION FieldValLen( var )	
	RETURN IF( (TNUM)=="D",LEN(DTOC( (TCHR) )),;
		IF( (TNUM)=="L",1,;
		IF( (TNUM)=="M",LEN( ATRIM( (TCHR) ) ),;
		IF( (TNUM)=="C",LEN( ATRIM( (TCHR) ) ),;
		IF( (TNUM)=="N",LEN( ATRIM( STR((TCHR)) ) ),-1 ) ))))

FUNCTION FieldDec( var )
	RETURN IF( (TNUM)<>"N", -1,;
		IF( (TNUM) == "N" .AND. "." $ STR( (TCHR) ),;
		LEN(STR( (TCHR) )) - AT(".", STR( (TCHR) )), 0 ))

/* hated to write it this way, but there's no other... save 'C' or
   .ASM in the case of a 100-field .DBF, you use more than 1300
   bytes memory plus overhead for a call that might return as
   little as 1 byte.  Nah!                                       */

FUNCTION FieldNum( var )
	LOCAL dbsarray:= Dbstruct()
	RETURN IF( (VTV)=="C" .AND. (FBV <> NIL),;
           ASCAN( dbsarray, {|e| UPPER(var)==e[DBS_NAME] } ), -1 )
/* EOF:  CHF.prg  */

/* Steve Kolterman is an indigent Clipper programmer residing in 
   the wealthy suburbs of Philadelphia.  His life is fraught with 
   mercilessly cruel ironies such as this, the cruelest of all.  In
   his spare time he enjoys brooding and ridiculing ineptitude.  
   His favorite target is Rick Dees.                             */

